<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright  2002 - 2008 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: mg_invitation.php
| Author: MarcusG
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
require_once "../../maincore.php";
require_once THEMES."templates/header.php";

// Turn off all error reporting
error_reporting(0);
// Report all PHP errors (see changelog)
//error_reporting(E_ALL);
//error_reporting(E_ALL & ~E_NOTICE);

include INFUSIONS."mg_invitation_panel/infusion_db.php";
include INFUSIONS."mg_invitation_panel/inc/functions.php";

// Check if locale file is available matching the current site locale setting.
if (file_exists(INFUSIONS."mg_invitation_panel/locale/".$settings['locale'].".php")) {
	// Load the locale file matching the current site locale setting.
	include INFUSIONS."mg_invitation_panel/locale/".$settings['locale'].".php";
} else {
	// Load the infusion's default locale file.
	include INFUSIONS."mg_invitation_panel/locale/German.php";
}
if (iMEMBER) {
add_to_head("
<style type='text/css'>
<!--
.success {
	color:green;
	font-weight:bold;
	text-align:center;
	font-size: 16px;
}

.error {
	color: #ff0000;
	font-weight:bold;
	text-align:center;
	font-size: 14px;
}
-->
</style>
");
// Auto-Lschen
	$zeit = time() - (invset("auto_delete") * 86400);
	$del_inv = dbcount("(mg_invite_id)", MG_INVITATION, "mg_inv_datestamp<=".$zeit );
	if($del_inv != 0) {
	$result = dbquery("DELETE FROM ".MG_INVITATION." WHERE mg_inv_datestamp<=".$zeit."");
	}
//
opentable($locale['MGINV_i001']);
echo "<div style='text-align:center;'><img src='".INFUSIONS."mg_invitation_panel/images/invite.png' title='".$locale['MGINV_i001']."' style='padding:15px;float:left;' /></div>\n";
echo "<div style='padding:25px;text-align:center;font-size:bigger;font-weight:bold;'>".parseubb(parsesmileys(nl2br(invset("page_text"))))."</div>\n";
// echo "<div style='clear:both;'></div>";

if (isset($_POST['weitersagen'])) {
	if ($_POST['mg_inv_friend_name'] != "") {
		$mg_inv_friend_name = stripinput($_POST['mg_inv_friend_name']);
		$error = "";
	} else {
		redirect(FUSION_SELF."?error=empty_friend");
	}
	if ($_POST['mg_inv_friend_mail'] != "") {
		$friend_email = stripinput(trim(preg_replace("/ +/i", "", $_POST['mg_inv_friend_mail'])));
		$result = dbquery("SELECT user_email FROM ".DB_USERS." WHERE user_email='".$friend_email."'");
		$result1 = dbquery("SELECT mg_inv_friend_mail FROM ".MG_INVITATION." WHERE mg_inv_friend_mail='".$friend_email."'");
		$email_domain = substr(strrchr($friend_email, "@"), 1);
		$result2 = dbquery("SELECT * FROM ".DB_BLACKLIST." WHERE blacklist_email='".$friend_email."' OR blacklist_email='".$email_domain."'");
		if (dbrows($result) != 0) {
			redirect(FUSION_SELF."?error=mail");
		} elseif (dbrows($result1) != 0) {
			redirect(FUSION_SELF."?error=invmail");
		} elseif (dbrows($result2) != 0) {
			redirect(FUSION_SELF."?error=blacklist");
		} elseif (validEmail($friend_email) != true) {
			redirect(FUSION_SELF."?error=notvalid");
		} else {
			$friend_email = stripinput(trim(preg_replace("/ +/i", "", $_POST['mg_inv_friend_mail'])));
		}
	} else {
		redirect(FUSION_SELF."?error=empty_mail");
	}
	if ($_POST['user_mail'] != "") {
		$user_mail = stripinput($_POST['user_mail']);
		$error = "";
	} else {
		redirect(FUSION_SELF."?error=empty_user_mail");
	}

	if ($error == "") {
		$mg_inv_user = stripinput($_POST['mg_inv_user']);
		$mg_inv_key = stripinput($_POST['mg_inv_key']);
		$user_name = stripinput($_POST['user_name']);
		$friend_message = utf8_encode(stripinput($_POST['friend_message']));
		$inv_message = utf8_encode(stripinput($_POST['inv_message']));
		$betreff = stripinput($_POST['betreff']);
		$result = dbquery("INSERT INTO ".MG_INVITATION." SET
		mg_inv_user='".$mg_inv_user."',
		mg_inv_friend_name='".$mg_inv_friend_name."',
		mg_inv_friend_mail='".$friend_email."',
		mg_inv_key='".$mg_inv_key."',
		mg_inv_datestamp='".time()."'
		");
		require_once INCLUDES."sendmail_include.php";
		$nachricht = "".$locale['MGINV_i002']." ".$mg_inv_friend_name.",\n".$friend_message."\n\n".$inv_message;
		$bcc_to = (invset("inv_bcc") == 1 ? invset("inv_bcc_to") : "");
		sendemail($mg_inv_friend_name, $friend_email, $user_name, $user_mail, $betreff, $nachricht, $type = "plain", $cc = "", $bcc = $bcc_to);

		$result = dbquery("INSERT INTO ".MG_INV_TOP." SET
		mg_inv_user = '".$mg_inv_user."',
		mg_inv_user_name = '".$user_name."',
		mg_inv_invite_score = '1'
		ON DUPLICATE KEY UPDATE
		mg_inv_invite_score = mg_inv_invite_score+1
		");
		// Scores falls vorhanden
		if (defined("SCORESYSTEM")) {
			if (invset("use_score") == '1') {
			score_free($locale['MGINV_i003'], "EINL", invset("inv_score"), 10, "P", 0, 0);
			}
		}
		redirect(FUSION_SELF."?success=true");
	} else {
		redirect(FUSION_SELF."?error=".$error);
	}

} else {
	if (isset($_GET['success'])) {
		echo "<div class='success'>".sprintf($locale['MGINV_i004'], invset("auto_delete"))."<br /><br /></div>";
	}

	if(isset($_GET['error']))
	{
	$error = stripinput($_GET['error']);
	} else {
	$error = "";
	}
		switch ($error) {
			case "empty_mail":
				echo "<div class='error'>".$locale['MGINV_i005']."<br /><br /></div>";
			break;
			case "empty_user_mail":
				echo "<div class='error'>".$locale['MGINV_i006']."<br /><br /></div>";
			break;
			case "empty_friend":
				echo "<div class='error'>".$locale['MGINV_i007']."<br /><br /></div>";
			break;
			case "invmail":
				echo "<div class='error'>".$locale['MGINV_i008']."<br /><br /></div>";
			break;
			case "blacklist":
				echo "<div class='error'>".$locale['MGINV_i009']."<br /><br /></div>";
			break;
			case "mail":
				echo "<div class='error'>".$locale['MGINV_i010']."<br /><br /></div>";
			break;
			case "notvalid":
				echo "<div class='error'>".$locale['MGINV_i011']."<br /><br /></div>";
			break;
		}
echo "<br /><br /><br />";
echo "<form name='weitersagen' id='weitersagen' method='post' action='".FUSION_SELF."' autocomplete='off'>\n";
echo "<table cellpadding='4' cellspacing='4' class='tbl-border center' width='95%'>\n";
echo "<tr class='tbl1'>
		<td style='text-align:right;width:35%;'>".$locale['MGINV_i012'].":<span style='font-weight:bold;color:red;'>&nbsp;*</span></td>
		<td style='text-align:left;width:65%;'>
			<input type='text' class='textbox' name='user_name' id='user_name' value='".$userdata['user_name']."' style='width:400px;' readonly />
		</td>
	</tr>
	<tr class='tbl1'>
		<td style='text-align:right;'>".$locale['MGINV_i013'].":<span style='font-weight:bold;color:red;'>&nbsp;*</span></td>
		<td style='text-align:left;'>
			<input type='text' class='textbox' name='mg_inv_friend_name' id='mg_inv_friend_name' style='width:400px;' />
		</td>
	</tr>
	<tr class='tbl1'>
		<td style='text-align:right;'>".$locale['MGINV_i014'].":<span style='font-weight:bold;color:red;'>&nbsp;*</span></td>
		<td style='text-align:left;'>
			<input type='text' class='textbox' name='mg_inv_friend_mail' id='mg_inv_friend_mail' style='width:400px;' />
		</td>
	</tr>
	<tr class='tbl1'>
		<td style='text-align:right;'>".$locale['MGINV_i015'].":<span style='font-weight:bold;color:red;'>&nbsp;*</span></td>
		<td style='text-align:left;'>
			<input type='text' class='textbox' name='user_mail' id='user_mail' value='".$userdata['user_email']."' style='width:400px;' />
		</td>
	</tr>
	<tr class='tbl1'>
		<td style='text-align:right;'>".$locale['MGINV_i016'].":<span style='font-weight:bold;color:red;'>&nbsp;*</span></td>
		<td style='text-align:left;'>
			<input type='text' class='textbox' name='betreff' id='betreff' value='".$locale['MGINV_i020']." ".$userdata['user_name']."' style='width:400px;' />
		</td>
	</tr>
	<tr class='tbl1'>
		<td style='text-align:right;vertical-align:top;'>".$locale['MGINV_i017'].":<span style='font-weight:bold;color:red;'>&nbsp;*</span></td>
		<td style='text-align:left;'>
			".$locale['MGINV_i002']." <span id='hello_friend_name'><span style='font-style:italic;'>".$locale['MGINV_i013']."</span></span>,
		</td>
	</tr>
	<tr class='tbl1'>
		<td style='text-align:right;vertical-align:top;'><span style='font-size:x-small;'><span style='font-weight:bold;color:red;'>*</span> = ".$locale['MGINV_i018']."</span></td>
		<td style='text-align:left;'><textarea class='textbox' name='friend_message' id='friend_message' rows='5' style='width:400px;'>".$locale['MGINV_i019']."\n".$userdata['user_name']."</textarea>";

		mt_srand((double)microtime()*1000000); $salt = "";
			for ($i = 0; $i <= 7; $i++) { $salt .= chr(rand(35, 99)); }
			$key = md5($userdata['user_email'].$salt);

		echo "<textarea class='textbox' name='inv_message' id='inv_message' rows='10' style='width:400px;' readonly>\n--------------------------------------------------------\n".$userdata['user_name']." ".$locale['MGINV_message1']."".$settings['siteurl']."mg_inv_register.php?key=".$key."\n\n".$locale['MGINV_message2']."".$key."\n\n--------------------------------------------------------\n".$locale['MGINV_message3']."
		</textarea>
		</td>
	</tr>
	<tr class='tbl1'>
		<td style='text-align:center;' colspan='2'>
			<input type='hidden' value='".$userdata['user_id']."' name='mg_inv_user' />
			<input type='hidden' value='".$key."' name='mg_inv_key' />
			<input type='submit' value='".$locale['MGINV_i001']."' name='weitersagen' id='submit_button' class='button' />
		</td>
	</tr>";


echo "</table>\n";
echo "</form>\n";
}
echo zeigeCopyright_inv();
closetable();
echo "<div style='padding:5px;'>".$locale['MGINV_i021']."&nbsp;&nbsp;<span style='font-weight:bold;font-size:xx-small;cursor:pointer;cursor:hand;'>[ <span id='zeigen' class='zeigen' style='display:none;'>".$locale['MGINV_i022']."</span><span id='verbergen' class='zeigen'>".$locale['MGINV_i023']."</span> ]</span></div>";

echo "<div id='inv_details'>";
opentable($locale['MGINV_i024']);

$inv_per_page = 10;

if (!isset($_GET['invrowstart']) || !isnum($_GET['invrowstart'])) {

	$_GET['invrowstart'] = 0;

}

$inv_rows = dbcount("(mg_invite_id)", MG_INVITATION, "mg_inv_user='".$userdata['user_id']."'");

$result = dbquery("SELECT * FROM ".MG_INVITATION." WHERE mg_inv_user='".$userdata['user_id']."' ORDER BY mg_inv_datestamp DESC LIMIT ".$_GET['invrowstart'].",".$inv_per_page."");
if (dbrows($result)) {
$i = 1;
echo "<table cellpadding='4' cellspacing='0' class='tbl-border center' width='50%'>\n";
echo "<tr class='tbl2' style='font-weight:bold;text-align:center;'>\n";
echo "<td>".$locale['MGINV_i025']."</td>\n
	<td>".$locale['MGINV_i026']."</td>\n
	<td>".$locale['MGINV_i027']."</td>\n
	<td>".$locale['MGINV_i028']."</td>\n";
echo "</tr>\n";
while ($data = dbarray($result)) {
	$class = (($i % 2) ? "tbl1" : "tbl2");
	echo "<tr class='".$class."' style='text-align:center;'>\n";
	echo "<td>".$data['mg_inv_friend_name']."</td>\n";
	echo "<td>".hide_email($data['mg_inv_friend_mail'])."</td>\n";
	echo "<td>".$data['mg_inv_key']."</td>\n";
	echo "<td>".showdate("%d.%m.%Y %H:%M:%S", $data['mg_inv_datestamp'])."</td>\n";
	echo "</tr>\n";
	$i++;
}

if ($inv_rows > $inv_per_page) {
	echo "<tr class='tbl2' style='text-align:center;'>\n<td colspan='4'>";
	echo custompagenav($_GET['invrowstart'], $inv_per_page, $inv_rows, 3, "", "invrowstart");
	echo "</td>\n</tr>\n";
}

echo "</table>";
} else {
	echo "<div style='text-align:center;'>".$locale['MGINV_i029']."</div>";
}
closetable();

opentable($locale['MGINV_i030']);
$reg_per_page = 10;

if (!isset($_GET['regrowstart']) || !isnum($_GET['regrowstart'])) {

	$_GET['regrowstart'] = 0;

}

$reg_rows = dbcount("(mg_invite_id)", MG_INV_ARCHIV, "mg_inv_user='".$userdata['user_id']."'");

$result = dbquery("SELECT inva.*, tblu.user_id, tblu.user_name FROM ".MG_INV_ARCHIV." as inva
LEFT JOIN ".DB_USERS." as tblu ON tblu.user_name=inva.mg_inv_friend_name
WHERE inva.mg_inv_user='".$userdata['user_id']."' ORDER BY inva.mg_inv_datestamp DESC LIMIT ".$_GET['regrowstart'].",".$reg_per_page."");
if (dbrows($result)) {
echo "<table cellpadding='4' cellspacing='0' class='tbl-border center' width='80%'>\n";
echo "<tr class='tbl2' style='font-weight:bold;text-align:center;'>\n";
echo "<td>".$locale['MGINV_i025']."</td>\n
	<td>".$locale['MGINV_i028']."</td>\n";
echo "</tr>\n";
$i = 1;
while ($data = dbarray($result)) {
	$class = (($i % 2) ? "tbl1" : "tbl2");
	echo "<tr class='".$class."' style='text-align:center;'>\n";
	echo "<td>".($data['user_id'] ? "<a href='".BASEDIR."profile.php?lookup=".$data['user_id']."'>" : "").$data['mg_inv_friend_name'].($data['user_id'] ? "</a>" : "")."</td>\n";
	//echo "<td>".hide_email($data['mg_inv_friend_mail'])."</td>\n";
	echo "<td>".showdate("%d.%m.%Y %H:%M:%S", $data['mg_inv_datestamp'])."</td>\n";
	echo "</tr>\n";
	$i++;
}

if ($reg_rows > $reg_per_page) {
	echo "<tr class='tbl2' style='text-align:center;'>\n<td colspan='3'>";
	echo custompagenav($_GET['regrowstart'], $reg_per_page, $reg_rows, 3, "", "regrowstart");
	echo "</td>\n</tr>\n";
}

echo "</table>\n";
} else {
	echo "<div style='text-align:center;'>".$locale['MGINV_i031']."</div>";
}
closetable();

opentable($locale['MGINV_i048']);
echo "<table cellpadding='4' cellspacing='4' class='tbl center' width='80%'>\n";
echo "<tr class='tbl1'>\n<td width='50%' style='vertical-align:top;'>";
// Top 10 Einladungen
echo "<table cellpadding='4' cellspacing='0' class='tbl-border center' width='100%'>\n";
echo "<tr class='tbl2' style='font-weight:bold;text-align:center;'>\n";
echo "<td colspan='2'>".$locale['MGINV_i032']."</td>\n";
echo "</tr>\n";
$result = dbquery("SELECT * FROM ".MG_INV_TOP." ORDER BY mg_inv_invite_score DESC, mg_inv_user_name ASC LIMIT 0,10");
if (dbrows($result)) {
$i = 1;
while ($data = dbarray($result)) {
	$class = (($i % 2) ? 'tbl1' : 'tbl2');
	echo "<tr class='".$class."' style='text-align:center;'>
		<td><a href='".BASEDIR."profile.php?lookup=".$data['mg_inv_user']."'>".$data['mg_inv_user_name']."</a></td>
		<td><span class='tip' title='".$data['mg_inv_user_name']." ".$locale['MGINV_i033']." ".$data['mg_inv_invite_score']." ".($data['mg_inv_invite_score'] == '1' ? $locale['MGINV_i034'] : $locale['MGINV_i034a'])." ".$locale['MGINV_i035']."'>[".$data['mg_inv_invite_score']."]</span></td></tr>";
		$i++;
}
} else {
echo "<tr class='tbl1' style='text-align:center;'>\n<td colspan='2'>".$locale['MGINV_i036']."</td>\n</tr>\n";
}

echo "</table>\n";
echo "</td>\n";
echo "<td width='50%' style='vertical-align:top;'>";
// Top 10 Registrierungen
echo "<table cellpadding='4' cellspacing='0' class='tbl-border center' width='100%'>\n";
echo "<tr class='tbl2' style='font-weight:bold;text-align:center;'>\n";
echo "<td colspan='2'>".$locale['MGINV_i037']."</td>\n";
echo "</tr>\n";
$result = dbquery("SELECT * FROM ".MG_INV_TOP." ORDER BY mg_inv_register_score DESC, mg_inv_user_name ASC LIMIT 0,10");
if (dbrows($result)) {
$i = 1;
while ($data = dbarray($result)) {
	$class = (($i % 2) ? 'tbl1' : 'tbl2');
	echo "<tr class='".$class."' style='text-align:center;'>
		<td><a href='".BASEDIR."profile.php?lookup=".$data['mg_inv_user']."'>".$data['mg_inv_user_name']."</a></td>
		<td><span class='tip' title='".$data['mg_inv_register_score']." ".$locale['MGINV_i038']." ".($data['mg_inv_register_score'] == 1 ? $locale['MGINV_i039'] : $locale['MGINV_i039a'])." ".$locale['MGINV_i040']." ".$data['mg_inv_user_name']."".$locale['MGINV_i041']."'>[".$data['mg_inv_register_score']."]</span></td></tr>";
		$i++;
}
} else {
echo "<tr class='tbl1' style='text-align:center;'>\n<td colspan='2'>".$locale['MGINV_i036']."</td>\n</tr>\n";
}

echo "</table>\n";
echo "</td></tr>\n";
echo "</table>\n";
closetable();

echo "</div>";

echo "<script type='text/javascript' src='".INFUSIONS."mg_invitation_panel/inc/jquery-1.4.1.min.js'></script>";
echo "<script type='text/javascript' src='".INFUSIONS."mg_invitation_panel/inc/jquery.qtip-1.0.0-rc3.min.js'></script>";
echo "<script type=\"text/javascript\">
	$(document).ready(function(){
	$('.success').fadeOut(15000);
	$('.error').fadeOut(10000);
	});
	$(function() {
	$('#mg_inv_friend_name').keyup(function() {
	$('#hello_friend_name').text($('#mg_inv_friend_name').val());
	});
	});

	$(function() {
		$('.tip[title]').qtip({ style: {
		width: 200,
		padding: 5,
		textAlign: 'center',
		border: {
			width: 3,
			radius: 5
		},
		name: 'cream', tip: true },
		position: {
			corner: {
				target: 'topRight',
				tooltip: 'bottomLeft'
			}
		}
		});
	});

	$(function() {
	$('#zeigen').click(function() {
	$('#inv_details').fadeIn('slow');
	$('.zeigen').toggle();
	});
	});

	$(function() {
	$('#verbergen').click(function() {
	$('#inv_details').fadeOut('slow');
	$('.zeigen').toggle();
	});
	});
</script>";
} else {
opentable($locale['MGINV_i042']);
echo "<div style='text-align:center;'><img src='".INFUSIONS."mg_invitation_panel/images/stop.png' title='".$locale['MGINV_i043']."' style='padding:15px;' /><br /><br />".$locale['MGINV_i044']."<br /><br />
<img src='".THEME."images/bullet.gif' /><a href='".BASEDIR."register.php'> ".$locale['MGINV_i045']." </a><img src='".THEME."images/bulletb.gif' /><br />
<img src='".THEME."images/bullet.gif' /><a href='".BASEDIR."lostpassword.php'> ".$locale['MGINV_i046']." </a><img src='".THEME."images/bulletb.gif' /><br />
<img src='".THEME."images/bullet.gif' /><a href='".BASEDIR."login.php'> ".$locale['MGINV_i047']." </a><img src='".THEME."images/bulletb.gif' /><br /><br /></div>\n";
closetable();
}
require_once THEMES."templates/footer.php";
?>