<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright  2002 - 2008 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: mg_invitation_panel.php
| Author: MarcusG
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
if (!defined("IN_FUSION")) { die("Access Denied"); }

include INFUSIONS."mg_invitation_panel/infusion_db.php";

$inf_einstellungen = dbarray(dbquery("SELECT * FROM ".MG_INV_SETTINGS." WHERE mg_inv_settings_id='1'"));

// Check if locale file is available matching the current site locale setting.
if (file_exists(INFUSIONS."mg_invitation_panel/locale/".$settings['locale'].".php")) {
	// Load the locale file matching the current site locale setting.
	include INFUSIONS."mg_invitation_panel/locale/".$settings['locale'].".php";
} else {
	// Load the infusion's default locale file.
	include INFUSIONS."mg_invitation_panel/locale/German.php";
}

if($inf_einstellungen['show_panel_content'] == 1) {
openside($locale['MGINV_desc']);

echo "<div style='text-align:center;'><a href='".INFUSIONS."mg_invitation_panel/mg_invitation.php'><img class='tip' src='".INFUSIONS."mg_invitation_panel/images/invite2.png' title='".$locale['MGINV_p001']."' style='padding:5px;border:0px;' /></a></div>\n";
echo "<table cellpadding='4' cellspacing='0' class='tbl-border center' width='100%'>\n";
echo "<tr class='tbl2' style='font-weight:bold;text-align:center;'>\n";
echo "<td colspan='3'>".sprintf($locale['MGINV_p002'], $inf_einstellungen['top_count'])."</td>\n";
echo "</tr>\n";
echo "<tr class='tbl1' style='font-weight:bold;text-align:center;'>\n";
echo "<td>Name</td><td width='1%'><img class='tip' src='".INFUSIONS."mg_invitation_panel/images/einladung.png' title='".$locale['MGINV_p003a']."' style='border:0px;' /></td><td width='1%'><img class='tip' src='".INFUSIONS."mg_invitation_panel/images/reg.png' title='".$locale['MGINV_p004']."' style='border:0px;' /></td>\n";
echo "</tr>\n";
$result = dbquery("SELECT * FROM ".MG_INV_TOP." ORDER BY mg_inv_invite_score DESC, mg_inv_register_score DESC, mg_inv_user_name ASC LIMIT 0,".$inf_einstellungen['top_count']."");
if (dbrows($result)) {
$i = 1;
while ($data = dbarray($result)) {
	$class = (($i % 2) ? 'tbl2' : 'tbl1');
	echo "<tr class='".$class."' style='text-align:center;'>
		<td><a href='".BASEDIR."profile.php?lookup=".$data['mg_inv_user']."'>".trimlink($data['mg_inv_user_name'], 15)."</a></td>
		<td><span class='tip' title='".$data['mg_inv_user_name']." ".$locale['MGINV_p005']." ".$data['mg_inv_invite_score']." ".($data['mg_inv_invite_score'] == '1' ? $locale['MGINV_p003'] : $locale['MGINV_p003a'])." ".$locale['MGINV_p006']."'>[".$data['mg_inv_invite_score']."]</span></td>
		<td><span class='tip' title='".$data['mg_inv_register_score']." ".$locale['MGINV_p007']." ".($data['mg_inv_register_score'] == 1 ? $locale['MGINV_p008'] : $locale['MGINV_p008a'])." ".$locale['MGINV_p009']." ".$data['mg_inv_user_name']."".$locale['MGINV_p010']."'>[".$data['mg_inv_register_score']."]</span></td></tr>";
		$i++;
}
} else {
echo "<tr class='tbl1' style='text-align:center;'>\n<td colspan='3'>".$locale['MGINV_p011']."</td>\n</tr>\n";
}

echo "</table>\n";

closeside();
}
// Auto-Lschen
	$zeit = time() - ($inf_einstellungen['auto_delete'] * 86400);
	$del_inv = dbcount("(mg_invite_id)", MG_INVITATION, "mg_inv_datestamp<=".$zeit );
	if($del_inv != 0) {
	$result = dbquery("DELETE FROM ".MG_INVITATION." WHERE mg_inv_datestamp<=".$zeit."");
	}
//
?>